unit private;

interface

uses crt,dos;

function computertype:string;
procedure setcursor(mode:byte);
procedure crtmode(X:byte);
procedure repeatsystem;
procedure resetsystem;
procedure coff;
procedure con;
procedure wait(t:longint); { t=max 360000ms  =>60 dakika }
function readrshift:boolean;
function readlshift:boolean;
function readctrl:boolean;
function readalt:boolean;
function readscroll:boolean;
function readnum:boolean;
function readins:boolean;
function readcaps:boolean;

implementation

function readrshift:boolean;
var Regs:Registers;
begin
regs.AH:=2;
  intr($16,regs);
  readrshift:=(regs.AL and $01) > 0;
end;

function readcaps:boolean;
var Regs:Registers;
begin
regs.AH:=2;
  intr($16,regs);
  readcaps:=(regs.AL and $40) > 0;
end;

function readlshift:boolean;
var Regs:Registers;
begin
regs.AH:=2;
  intr($16,regs);
  readlshift:=(regs.AL and $02) > 0;
end;

function readctrl:boolean;
var Regs:Registers;
begin
regs.AH:=2;
  intr($16,regs);
  readctrl:=(regs.AL and $04) > 0;
end;

function readalt:boolean;
var Regs:Registers;
begin
regs.AH:=2;
  intr($16,regs);
  readalt:=(regs.AL and $08) > 0;
end;

function readscroll:boolean;
var Regs:Registers;
begin
regs.AH:=2;
  intr($16,regs);
  readscroll:=(regs.AL and $10) > 0;
end;

function readnum:boolean;
var Regs:Registers;
begin
regs.AH:=2;
  intr($16,regs);
  readnum:=(regs.AL and $20) > 0;
end;

function readins:boolean;
var Regs:Registers;
begin
regs.AH:=2;
  intr($16,regs);
  readins:=(regs.AL and $20) > 0;
end;


function computertype:string;
var
 tip:byte;
begin
tip:=mem[$f000:$fffe];
case tip of
$ff:computertype:='PC';
$fe:computertype:='XT and PORTABLE';
$fd:computertype:='PC jr';
$fc:computertype:='AT';
else computertype:='';
end;
end;

procedure setcursor(mode:byte);
procedure cur(x,y:byte);
begin
inline($b4/$01/
       $8a/$6e/<x/
       $8a/$4e/<y/
       $cd/$10);
end;
begin
{12,12,11,12,10,12,9,12,2,12  -12,11,12,5,12,0     }
if mode = 0 then cur(12,0);
if mode = 1 then cur(12,5);
if mode = 2 then cur(12,11);
if mode = 3 then cur(2,12);
if mode = 4 then cur(9,12);
if mode = 5 then cur(10,12);
if mode = 6 then cur(11,12);
if mode = 7 then cur(12,12);
end;

procedure crtmode(X:byte);
begin
inline($b4/$00/$8a/$46/$04/$cd/$10);
end;

procedure repeatsystem;begin inline($eb/$fe);end;
procedure resetsystem;begin inline($ea/$f0/$ff/$00/$f0);end;

procedure coff;
var r:registers;
begin r.ah:=$01;  r.cx:=$2000; intr($10,r);
end;

procedure con;
var r:registers;
begin r.ah:=$01;  r.cx:=$1012; intr($10,r);
end;

procedure wait(t:longint);
  var sa,da,sn,ss:word;
      hsa,hda,hsn,hss:word;
      tus2:char;
      artik_salise:word;
      dak,san,sal:word;
 begin

  { 80486SX CPU iin} if t<5 then  t:=0;

  dak:=0;
  san:=0;
  sal:=0;

 { salise dak san sal cinsinden dntrlyor}
      if t<=360000 then
      begin dak:=round( (t-(t mod 6000))/6000 );t:=t mod 6000;end;
      if t<6000 then
      begin san:=round( (t-(t mod 100))/100 );t:=(t mod 100);end;
      if t<100 then sal:=t;

  gettime(sa,da,sn,ss); { zaman alnyor}
  hsa:=sa;
  hda:=da;
  hsn:=sn;
  hss:=ss;

 { hedef zaman belirleniyor =>hsa hda hsn hss}

      hss:=ss+sal;
      hsn:=sn+san;
      hda:=da+dak;

       if hss>99 then begin hsn:=hsn+1; hss:=hss mod 99;end;
       if hsn>59 then begin hda:=hda+1; hsn:=hsn mod 59;end;
       if hda>59 then begin hsa:=hsa+1; hda:=hda mod 59;end;
       if hsa>23 then begin hsa:=0;hda:=0;hsn:=0;hss:=0;end;

                                     {
                                     btc(1,15);window(10,10,30,15);clrscr;
                                     writeln(sa,':',da,':',sn,':',ss);
                                     writeln(t,' => ',dak,':',san,':',sal);
                                     writeln(hsa,':',hda,':',hsn,':',hss);
                                     }

      { hedef zamana kadar dng devam ediyor}

         repeat
          gettime(sa,da,sn,ss);
         until (sa>=hsa) and (da>=hda) and (sn>=hsn) and (ss>=hss);

 end;



end.
